<?php
/**
 * Block outgoing spam
 *
 * @version 1.7.3 - 10.09.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 *
 **/
 
/**
 * Usage: http://mail4us.net/myroundcube/
 *
 **/ 
 
class blockspamsending extends rcube_plugin
{
  public $task = 'mail|settings';
  public $noframe = true;
  public $noajax = true;
  
  /* unified plugin properties */
  static private $plugin = 'blockspamsending';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = '<a href="http://myroundcube.com/myroundcube-plugins/blockspamsending-plugin;" target=_new>Documentation</a>';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '1.7.3';
  static private $date = '10-09-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.7.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';

  function init()
  {
    $this->add_hook('message_outgoing_body', array($this,'body'));
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  function body($args)
  {
    if(get_input_value('_draft', RCUBE_INPUT_POST)){
      return $args;
    }
    $rcmail = rcmail::get_instance();
    if(!in_array('global_config', $rcmail->config->get('plugins'))){
      $this->load_config();
    }
    $body = trim($args['body']);
    $tbody = new html2text($body);
    $out = $tbody->get_text();
    $out = preg_replace('/\s+/', '', $out);
    $out = preg_replace("/(\r|\n|\t)/", '', $out);
    if($out == "")
      return $args;
    $body_hash = md5($out);
    if(!isset($_SESSION[$body_hash]))
      $_SESSION[$body_hash] = 0;
    else{
      $_SESSION[$body_hash] = $_SESSION[$body_hash] + 1;
    }
    if($_SESSION[$body_hash] > $rcmail->config->get('body_tolerance',1)){
      write_log('blockspam',$_SESSION['username'] . " " . $_SERVER['REMOTE_ADDR'] . " " . $_SESSION[$body_hash]); 
      $rcmail->output->command('display_message',$this->gettext('sendingfailed'),'error');
      $rcmail->output->send('iframe');
    }

    return $args;
  }
}
?>