<?php
/**
 * compose_in_taskbar
 *
 * @version 2.5 - 02.11.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 * 
 **/
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 **/
 
class compose_in_taskbar extends rcube_plugin
{
  private $supported_skins = array('classic' => 1, 'meh' => 1, 'litecube-f' => 1, 'litecube' => 1, 'larry' => 1);
  
  /* unified plugin properties */
  static private $plugin = 'compose_in_taskbar';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = '<a href="http://myroundcube.com/myroundcube-plugins/compose_in_taskbar-plugin" target="_new">Documentation</a>';
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '2.5';
  static private $date = '02-11-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.8.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = null;
  static private $config_dist = null;
  
  function init()
  {
    $rcmail = rcmail::get_instance();
    $skin = $rcmail->config->get('skin','classic');
    if(isset($this->supported_skins[$skin])){
      $this->add_texts('localization/');
      $this->include_script('compose_in_taskbar.js');
      $skin_path = 'skins/'.$skin;
      $this->include_stylesheet($skin_path . "/compose_in_taskbar.css");
      $onclick = "try{composenewwindowcommandcaller('compose', ' ')} catch(e){document.location.href='./?_task=mail&_action=compose'}";
      $this->add_button(array(
          'command' => 'tcompose',
          'onclick' => $onclick,
          'type' => 'link',
          'class' => 'button-compose',
          'id' => 'compose_button',
          'content' => html::tag('span', array('class' => 'button-inner'), $this->gettext('compose_in_taskbar.compose')),
          'style' => 'display: none;'
        ),
        'taskbar'
      );
      $this->add_hook('render_page', array($this, 'render_page'));
    }
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }

  function render_page($args)
  {
    $rcmail = rcmail::get_instance();
    if($args['template'] == 'planner.planner'){
      $this->include_script("planner_drag_birthdays.js");
    }
    $s = array("return rcmail.command('tcompose','',this)");
    $r = array("var oldtask = rcmail.env.task; rcmail.env.task='mail'; if(rcmail.env.compose_newwindow){return composenewwindowcommandcaller('compose','',this); rcmail.env.task=oldtask}else{return rcmail.command('compose','',this); rcmail.env.task=oldtask}");
    $args['content'] = str_replace($s, $r,$args['content']);
    return $args;
  }
}
?>