<?php

/**
  * This plugin lets you impersonate another user using a master login.
  *  
  * @author Roland 'rosali' Liebl (myroundcube@mail4us.net) / Cor Bosman (roundcube@wa.ter.net)
  * @version 1.7.1 - 01.09.2012
  * @website http://myroundcube.googlecode.com
  *
  */

/**
  * Requirements: savepassword plugin (do not register, plugin is loaded automatically)
  *
  * Usage: Login: user@mydomain.com*master@mydomain.com
  *        Pass:  masterpassword
  * 
  */

class impersonate extends rcube_plugin {

  /* unified plugin properties */
  static private $plugin = 'impersonate';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = null;
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '1.7.1';
  static private $date = '01-09-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.7.1',
    'PHP' => '5.2.1'
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';
  
  public function init() 
  { 
    $this->add_hook('authenticate', array($this, 'login'));  
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $plugin,
            );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  function login($data) {
    $rcmail = rcmail::get_instance();
    if(!in_array('global_config', $rcmail->config->get('plugins'))){
      $this->load_config();
    }
    $this->require_plugin('savepassword');
    $seperator = $rcmail->config->get('impersonate_seperator', '*');
    
    if(strpos($data['user'], $seperator)) {
      $arr = explode($seperator, $data['user']);
      if(count($arr) == 2) {
        if(class_exists('hmail_login')){
          if(!strstr($arr[1],'@'))
            $arr[1] = $arr[1] . "@" . $rcmail->config->get('hmail_default_domain');
          $arr[1] = hmail_login::resolve_alias($arr[1]);
        }
        $query = 'SELECT * FROM '.get_table_name('users').' WHERE username=?';
        $ret = $rcmail->db->query($query,$arr[1]);
        $user = $rcmail->db->fetch_assoc();
        if(isset($user['password']) && $arr[1] == $rcmail->config->get('impersonate_master')){
          $pass = get_input_value('_pass', RCUBE_INPUT_GPC);
          if($pass == $rcmail->decrypt($user['password'])){
            $query = 'SELECT * FROM '.get_table_name('users').' WHERE username=?';
            if(class_exists('hmail_login')){
              if(!strstr($arr[0],'@'))
                $arr[0] = $arr[0] . "@" . $rcmail->config->get('hmail_default_domain');
              $arr[0] = hmail_login::resolve_alias($arr[0]);
            }
            $ret = $rcmail->db->query($query,$arr[0]);
            $user = $rcmail->db->fetch_assoc();
            $data['user'] = $arr[0];
            $data['pass'] = $rcmail->decrypt($user['password']);
            $_SESSION['impersonate'] = true;
          }
        }
      }
    }
    return($data);
  }  
}
?>