<?php
class http_request
{
	function __construct($type,$host,$file,$port = 80,$ssl = false,$http_v = 'HTTP/1.1')
	{
		$this->host = $host;
		$this->port = $port;
		if(!$this->set_type($type)){
			$this->response='ERROR: please set a request type';
			return $this->response;
			exit;
    }
		$this->file = $file;
		$this->http_v = $http_v;
		$this->add_header('Host',$host);
		$this->add_header('Connection','Close');
		$this->ssl = $ssl;
		$this->response = '';
	}
	
	function proxy($host,$port)
	{
		$this->con = @$this->connect($host,$port);
		if(!$this->con){
			$this->response='ERROR: the proxy on host "'.$host.'" did not response on port '.$port;
			return $this->response;
			exit;		
    }
		$this->proxy_con = true;
	}
	
	function connect($host,$port)
	{
		if(!is_numeric($port)){
			$this->response='ERROR: but this is not a port: '.$port;
			return $this->response;
			exit;		
		}
		if($this->ssl)
      $ssl = "ssl://";
    else
      $ssl = "";
            
		preg_match('@^(?:(?:25[0-5]|2[0-4]\d|[01]\d\d|\d?\d)(?(?=\.?\d)\.)){4}$@i', $host, $ip);
		if($ip[0]!='')
			return fsockopen($ssl.$host,$port);
		else
			return fsockopen($ssl.gethostbyname($host),$port);	
	}
	
	function get_ascii_file_content($file)
	{
		$content = @file_get_contents($file);
		if($content==''){
			$this->response = 'ERROR: can not access file or file is empty';
			return $this->response;
			exit;
		}
		return $content;
	}
	
	function get_bin_file_content($file)
	{
		$handle = @fopen($file, "rb");
		if(!$handle){
			$this->response = 'ERROR: can not access file';
			return $this->response;
			exit;
		}
		$content = fread ($handle, filesize($file));
		fclose ($handle);
		return $content;
	}
	
	function send($set_ct = true)
	{
		if($set_ct==true)
			$this->set_content_type();
		if(!isset($this->proxy_con)){
			$this->proxy_con = false;
		}
		if($this->proxy_con != true)
		{
			$this->con = @$this->connect($this->host,$this->port);
			if(!$this->con){
				$this->response = 'ERROR: "'.$this->host.'" did not response on port '.$this->port;
				return $this->response;
				exit;
			}
		}
		
		$this->send_data = '';
		$contentlength = 0;
		
		if($this->type=='GET')
		{
			$get_str='';
			if(!isset($this->data)){
				$this->data = false;
			}
			if($this->data)
			{
				foreach($this->data as $name => $value)
				{
					$get_str .=  $name.'='.$value.'&';
				}
			}
			$this->file.='?'.substr($get_str,0,-1);
			
		}
		else //// all other request types (POST, CONNECT ...)
		{
			if(!isset($this->boundary)){
				$this->boundary = false;
			}
			if($this->boundary)
			{
				if($this->data)
				{
					foreach($this->data as $name => $value) 
					{
						$contentlength += strlen("--".$this->boundary."\nContent-Disposition: form-data; name=\"".$name."\"\n\n".$value."\n");
						$this->send_data.=("--".$this->boundary."\nContent-Disposition: form-data; name=\"".$name."\"\n\n".$value."\n"); 
					}
				}
				$contentlength += strlen($this->boundary)+3;
				$this->add_header('Content-length',$contentlength);
				$this->send_data.= "--".$this->boundary."--\n";
			}
			else
			{
				if(is_array($this->data)){
				 foreach($this->data as $name => $value) 
				 {
					$this->send_data.= $name.'='.$value.'&';
				 }
				 $this->send_data = substr($this->send_data,0,-1);
				 $contentlength = strlen($this->send_data);
				 $this->add_header('Content-length',$contentlength);
				}
			}
		}
		if($this->proxy_con==true)
			$this->send_header = $this->type.' '.'http://'.$this->host.$this->file.' '.$this->http_v."\r\n";
		else
			$this->send_header = $this->type.' '.$this->file.' '.$this->http_v."\r\n";
		foreach($this->header as $head_name => $head_value)
			$this->send_header .= $head_name.': '.$head_value."\r\n";
		$this->send_header .= "\n";
		$this->packet = $this->send_header.$this->send_data;
		$this->send_to_host($this->packet);
	}
	
	function send_to_host($packet)
	{
		if(get_resource_type($this->con)!='stream'){
			$this->response = 'ERROR: no connection';
			return $this->response;
			exit;
		}
		fputs($this->con,$packet);
	  if($this->proxy_con==true) 
	  {
	    $this->response='';
	    while (!feof($this->con)) {
	      $this->response.=fgets($this->con);
	    }
	  }
	  else 
	  {
	    $this->response='';
	    while ((!feof($this->con)) or (!eregi(chr(0x0d).chr(0x0a).chr(0x0d).chr(0x0a),$this->response))) {
	      $this->response.=fread($this->con,1);
	    }
	  }
	  fclose($this->con);
	}

	function set_content_type()
	{
		if(!isset($this->files)){
			$this->files = 0;
		}
		if($this->files > 0)
		{
			$this->boundary = '---------------------------'.rand(1,9999999999);
			$this->add_header('Content-Type','multipart/form-data; boundary='.$this->boundary);
		}
		elseif($this->type!='GET')
			$this->add_header('Content-Type','application/x-www-form-urlencoded');	
	}

	function add_cookies($cookies)
	{
		if(!is_array($cookies)){
			$this->response = 'ERROR: we need an array for the cookies';
			return $this->response;
			exit;		
		}
		$cookie_str = "";
		foreach($cookies as $cookie_name => $cookie_value){
			$cookie_str .= $cookie_name.'='.$cookie_value.'; ';
		}
		$cookie_str = substr($cookie_str,0,-2);
		$this->add_header('Cookie',$cookie_str);
	}
	
	function set_type($name)
	{
		$name = strtoupper($name);
		$types = array('GET','HEAD','POST','PUT','DELETE','TRACE','CONNECT');
		if( in_array($name,$types) )
		{
			$this->type = $name;
			return true;
		}
		else
		{
			return false;	
		}
	}

	function add_data($name,$value)
	{
		$this->data[$name] = $value;
	}
	
	function add_file($name,$filename,$content)
	{
		if($this->type=='GET'){
			$this->response = 'ERROR: please do not use file uploads in get requests';
			return $this->response;
			exit;			
		}
		$this->files ++;
		$this->add_data($name.'"; filename="'.$filename,$content);
	}
	
	function add_header($name,$value)
	{
		$this->header[$name]=$value;
	}
}
?>