<?php

// Required hMailServer Database Version
// SELECT * FROM hm_dbversion
define('REQUIRED_HMAIL_DB', 5400);

// remove plus addressing characters
function rcube_register_trim_user($name = "", $domain = ""){

  $rcmail = rcmail::get_instance();
  $pladdrstr = $rcmail->config->get('pladdrstr'); 
  $repl = $pladdrstr[$domain];
  if($repl == "+"){
    if(strpos($name,$repl)){
      $name = str_replace($repl, '_', $name);
      echo "js:var repl = \"" . $name . "\";";
      exit;
    }
  }
  if($repl == "_"){
    if(strpos($name,$repl)){  
      $name = str_replace($repl, '-', $name);
      echo "js:var repl = \"" . $name . "\";";
      exit;
    }
  }
  if($repl == "-"){
    if(strpos($name,$repl)){  
      $name = str_replace($repl, '_', $name);
      echo "js:var repl = \"" . $name . "\";";
      exit;
    }
  }  
  if($repl == "%"){
    if(strpos($name,$repl)){  
      $name = str_replace($repl, '_', $name);
      echo "js:var repl = \"" . $name . "\";";
      exit;
    }
  } 
  
  return $name;
  
}

// check if user already exists
function rcube_register_user_exists($user = ""){

  $user = strtolower($user);
  $temparr = explode("@",$user);
  $name = strtolower($temparr[0]);
  $domain = strtolower($temparr[1]);
  $name = rcube_register_trim_user($name, $domain);
  
  $rcmail = rcmail::get_instance();
  
  if ($dsn = $rcmail->config->get('db_dsnw_hmailserver')) {
    // #1486067: enable new_link option
    if (is_array($dsn) && empty($dsn['new_link']))
      $dsn['new_link'] = true;
    else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
      $dsn .= '?new_link=true';  
    $db = new rcube_mdb2($dsn, '', FALSE);
    $db->set_debug((bool)$rcmail->config->get('sql_debug'));
    $db->db_connect('w');
  } else {
    die("FATAL ERROR ::: RoundCube Plugin ::: register ::: \$rcmail_config['db_dsnw_hmailserver'] undefined !!! ==> die");
  }
    
  if ($err = $db->is_error())
    return false;    
  
  // get domain id
  $query = "SELECT * FROM hm_domains WHERE domainname=?";
  $sql = $db->query($query, $domain);
  $arr = $db->fetch_assoc($sql);
  
  $strDomainID = $arr['domainid'];
  $strDomain = $arr['domainname'];
  $strUser = $name . "@" . $strDomain;
  
  $query = "SELECT * FROM hm_accounts WHERE accountaddress=? AND accountdomainid=?";
  $sql = $db->query($query, $strUser, $strDomainID);
  $arr = $db->fetch_assoc($sql);
   
  if(is_array($arr)){
    return true; // user exists
  }
  else{
    return false; //user does not exists
  }

}
      
// check if alias already exits
function rcube_register_alias_exists($user = ""){

  $user = strtolower($user);
  $temparr = explode("@",$user);
  $name = strtolower($temparr[0]);
  $domain = strtolower($temparr[1]);
  
  $name = rcube_register_trim_user($name, $domain);
  
  $rcmail = rcmail::get_instance();
  
  if ($dsn = $rcmail->config->get('db_dsnw_hmailserver')) {
    // #1486067: enable new_link option
    if (is_array($dsn) && empty($dsn['new_link']))
      $dsn['new_link'] = true;
    else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
      $dsn .= '?new_link=true';  
    $db = new rcube_mdb2($dsn, '', FALSE);
    $db->set_debug((bool)$rcmail->config->get('sql_debug'));
    $db->db_connect('w');
  } else {
    die("FATAL ERROR ::: RoundCube Plugin ::: register ::: \$rcmail_config['db_dsnw_hmailserver'] undefined !!! ==> die");
  }
    
  if ($err = $db->is_error())
    return false;
     
  $query = "SELECT * FROM hm_aliases WHERE aliasname=?";
  $sql = $db->query($query, $user);
  $arr = $db->fetch_assoc($sql);
   
  if(is_array($arr)){
    return true; // alias exists
  }
  else{
    return false; //alias does not exists
  }

}

// add user
function rcube_register_new_imap_user($user = "", $pass = ""){

  $user = strtolower($user);
  $temparr = explode("@",$user);
  $name = strtolower($temparr[0]);
  $domain = strtolower($temparr[1]);
  
  $name = rcube_register_trim_user($name, $domain);
  
  $rcmail = rcmail::get_instance();

  if ($dsn = $rcmail->config->get('db_dsnw_hmailserver')) {
    // #1486067: enable new_link option
    if (is_array($dsn) && empty($dsn['new_link']))
      $dsn['new_link'] = true;
    else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
      $dsn .= '?new_link=true';  
    $db = new rcube_mdb2($dsn, '', FALSE);
    $db->set_debug((bool)$rcmail->config->get('sql_debug'));
    $db->db_connect('w');
  } else {
    echo("error:FATAL ERROR ::: RoundCube Plugin ::: register ::: \$rcmail_config['db_dsnw_hmailserver'] undefined !!! ==> die");
    exit;
  }
    
  if ($err = $db->is_error())
    return false;
    
  $query = "SELECT * FROM hm_dbversion";
  $sql = $db->query($query);
  $arr = $db->fetch_assoc($sql);
  
  if($arr['value'] != REQUIRED_HMAIL_DB){
    echo "error:Required hMailServer Database Version " . REQUIRED_HMAIL_DB . ". Detected Database Version " . $arr['value'] . ".";
    exit;
  }    
  
  // get domain id
  $query = "SELECT * FROM hm_domains WHERE domainname=?";
  $sql = $db->query($query, $domain);
  $arr = $db->fetch_assoc($sql);
  
  $strDomainID = $arr['domainid'];
  $strDomain = $arr['domainname'];
  $strUser = $name . "@" . $strDomain;

  $query = "INSERT INTO hm_accounts ".
            "(accountdomainid,".
            "accountaddress,".
            "accountpassword,".
            "accountactive,".
            "accountisad,".
            "accountmaxsize,".
            "accountpwencryption,".
            "accountadminlevel,".
            "accountaddomain,".
            "accountadusername,".
            "accountvacationmessageon,".
            "accountvacationmessage,".
            "accountvacationsubject,".
            "accountforwardenabled,".
            "accountforwardaddress,".
            "accountforwardkeeporiginal,".
            "accountenablesignature,".
            "accountsignatureplaintext,".
            "accountsignaturehtml,".
            "accountlastlogontime,".
            "accountvacationexpires,".
            "accountvacationexpiredate,".
            "accountpersonfirstname,".
            "accountpersonlastname) ".
            "VALUES (?, ?, ? ,'1','0', ?,'2','0','','','0','','','0','','0','0','','','" . date('Y-m-d H:i:s',time()) . "','0','" . date('Y-m-d H:i:s',time()) . "','','');";
            
  $ret = $db->query($query, $strDomainID, $strUser, md5($pass), $rcmail->config->get('mailbox_limit'));
  
  $query = "SELECT * FROM hm_accounts WHERE accountaddress=?";
  $sql = $db->query($query, $strUser);
  $arr = $db->fetch_assoc($sql);
  $date = date('Y-m-d H:i:s', time());
  
  $query = "INSERT INTO hm_imapfolders " .
            "(folderaccountid,folderparentid,foldername,folderissubscribed,foldercreationtime,foldercurrentuid) " .
            "VALUES (?, '-1', 'INBOX' , '1', ?, '0');";
            
  $ret = $db->query($query, $arr['accountid'], $date);
  
  if($ret){ 
    return true; // user successfully created
  }
  else{
    return false; // failed to create user
  }
  
}

?>