<?php
// trim user
function rcube_register_trim_user($name = "", $domain = ""){
  return $name;
}

// check if user already exists
function rcube_register_user_exists($user = ""){
  $user = strtolower($user);
  $temparr = explode("@",$user);
  $name = strtolower($temparr[0]);
  $domain = strtolower($temparr[1]);
  $name = rcube_register_trim_user($name, $domain);
  $rcmail = rcmail::get_instance();
  if ($dsn = $rcmail->config->get('db_dsnw_postfix')) {
    // #1486067: enable new_link option
    if(is_array($dsn) && empty($dsn['new_link']))
      $dsn['new_link'] = true;
    else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
      $dsn .= '?new_link=true';
    $db = new rcube_mdb2($dsn, '', FALSE);
    $db->set_debug((bool)$rcmail->config->get('sql_debug'));
    $db->db_connect('w');
  } else {
    die("FATAL ERROR ::: RoundCube Plugin ::: register ::: " . $rcmail_config['db_dsnw_postfix'] . " undefined !!! ==> die");
  }

  if ($err = $db->is_error())
    return false;

  // get domain id
  $strDomain = $arr['domainname'];
  $strUser = $name . "@" . $domain;

  $query = "SELECT * FROM mailbox WHERE username=?";
  $sql = $db->query($query, $strUser);
  $arr = $db->fetch_assoc($sql);

  if(is_array($arr)){
    return true; // user exists
  }
  else{
    return false; //user does not exists
  }
}

// check if alias already exits
function rcube_register_alias_exists($user = ""){
  $user = strtolower($user);
  $temparr = explode("@",$user);
  $name = strtolower($temparr[0]);
  $domain = strtolower($temparr[1]);
  $strUser = $name . "@" . $domain;

  $name = rcube_register_trim_user($name, $domain);

  $rcmail = rcmail::get_instance();

  if ($dsn = $rcmail->config->get('db_dsnw_postfix')) {
    // #1486067: enable new_link option
    if (is_array($dsn) && empty($dsn['new_link']))
      $dsn['new_link'] = true;
    else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
      $dsn .= '?new_link=true';
    $db = new rcube_mdb2($dsn, '', FALSE);
    $db->set_debug((bool)$rcmail->config->get('sql_debug'));
    $db->db_connect('w');
  } else {
    die("FATAL ERROR ::: RoundCube Plugin ::: register ::: " . $rcmail_config['db_dsnw_postfix'] . " undefined !!! ==> die");
  }

  if ($err = $db->is_error())
    return false;

  $query = "SELECT * FROM alias WHERE address=?";
  $sql = $db->query($query, $strUser);
  $arr = $db->fetch_assoc($sql);

  if(is_array($arr)){
    return true; // alias exists
  }
  else{
    return false; //alias does not exists
  }
}

// add user
function rcube_register_new_imap_user($user = "", $pass = ""){
  $user = strtolower($user);
  $temparr = explode("@",$user);
  $name = strtolower($temparr[0]);
  $domain = strtolower($temparr[1]);

  $name = rcube_register_trim_user($name, $domain);

  $rcmail = rcmail::get_instance();

  if ($dsn = $rcmail->config->get('db_dsnw_postfix')) {
    // #1486067: enable new_link option
    if (is_array($dsn) && empty($dsn['new_link']))
      $dsn['new_link'] = true;
    else if (!is_array($dsn) && !preg_match('/\?new_link=true/', $dsn))
      $dsn .= '?new_link=true';
    $db = new rcube_mdb2($dsn, '', FALSE);
    $db->set_debug((bool)$rcmail->config->get('sql_debug'));
    $db->db_connect('w');
  } else {
    die("FATAL ERROR ::: RoundCube Plugin ::: register ::: " . $rcmail_config['db_dsnw_postfix'] . " undefined !!! ==> die");
  }

  if ($err = $db->is_error())
    return false;

  $strDomain = $arr['domainname'];
  $strUser = $name . "@" . $domain;
  $maildir = $domain . "/" . $name . "/";

  $query = "INSERT INTO mailbox ".
    "(username,".
    "password,".
    "name,".
    "maildir,".
    "quota,".
    "local_part,".
    "domain,".
    "created,".
    "modified,".
    "active) ".
    "VALUES (?, ?, ? , ?, ?, ?, ?,'" . date('Y-m-d H:i:s',time()) . "','" . date('Y-m-d H:i:s',time()) . "','1');";

  $ret = $db->query($query, $strUser, crypt($pass), $name, $maildir,
  $rcmail->config->get('mailbox_limit'), $name, $domain);

  $query = "INSERT INTO alias " .
    "(address,".
    "goto,".
    "domain,".
    "created,".
    "modified,".
    "active) ".
    "VALUES ( ?, ?, ? ,'" . date('Y-m-d H:i:s',time()) . "','" .
    date('Y-m-d H:i:s',time()) . "','1');";
  
  $sql = $db->query($query, $strUser, $strUser, $domain);
  $query = "SELECT * FROM mailbox WHERE username=?";
  $ret = $db->query($query, $strUser);
  if($ret){
    return true; // user successfully created
  }
  else{
    return false; // failed to create user
  }
}
?>
