<?php

/*
 +-----------------------------------------------------------------------+
 |                                                                       |
 | PURPOSE:                                                              |
 |   Send mailbox contents as RSS feed                                   |
 |                                                                       |
 +-----------------------------------------------------------------------+
 | Author: Roland 'rosali' Liebl <myroundcube@mail4us.net>               |
 +-----------------------------------------------------------------------+

 $Id$

*/

///////////////
// RSS Encoding
///////////////

function api_rss_encode($string){
  $content = @htmlspecialchars($string,ENT_NOQUOTES,'UTF-8',false);
  return $content;
}

function XMLClean($string) {
  $strout = null;
  for($i=0;$i<strlen($string);$i++){
    $ord = ord($string[$i]);
    //if(($ord > 0 && $ord < 32) || $ord >= 127){
    if($ord==177 || $ord==187){
      $strout .= "&#{$ord};";
    }
    else{
      $strout .= $string[$i];
    }
  }
  return $strout;
}
///// END FUNCTIONS /////

$imap_charset = 'UTF-8';

$mbox = "INBOX";
if(!empty($_GET['_mbox']))
  $mbox = strtolower(urldecode(trim($_GET['_mbox'])));
  
if(is_array($CONFIG['default_folders'])){
  if(in_array(ucwords($mbox), $CONFIG['default_folders'])   ||
    in_array(strtolower($mbox), $CONFIG['default_folders']) ||
    in_array(strtoupper($mbox), $CONFIG['default_folders']) ||
    in_array($mbox, $CONFIG['default_folders'])
  ){
    $disp_mbox = rcube_label(strtolower($mbox));
  }
  else{
    $disp_mbox = $mbox;
  }
}
else{
  $disp_mbox = $mbox;
}

$webmail_url = 'http';
if (rcube_https_check())
  $webmail_url .= 's';
$webmail_url .= '://'.$_SERVER['SERVER_NAME'];
if ($_SERVER['SERVER_PORT'] != '80')
	$webmail_url .= ':'.$_SERVER['SERVER_PORT'];

if (dirname($_SERVER['SCRIPT_NAME']) != '/')
	$webmail_url .= dirname($_SERVER['SCRIPT_NAME']) . '/';

$webmail_url = str_replace("\\","",$webmail_url);

$root_url = $webmail_url;

$webmail_url .= '?_task=mail';

$allowed_flags = array('all','unseen','flagged','unanswered','deleted');

$flag = "all";
$iflag = "seen";
$cflag = FALSE;

if(!empty($_GET['_flag']))
  $gflag = strtolower(urldecode(trim($_GET['_flag'])));
  
$fa = array_flip($allowed_flags);
if(!empty($fa[$gflag]))
  $flag = $gflag;

if($flag == "all"){
  $iflag = "unset";
  $cflag = FALSE;
}

if($flag == "unseen"){
  $iflag = "seen";
  $cflag = FALSE;
}
if($flag == "flagged"){
  $iflag = "flagged";
  $cflag = TRUE;
}
if($flag == "unanswered"){
  $iflag = "answered";
  $cflag = TRUE;
}
if($flag == "deleted"){
  $iflag = "deleted";
  $cflag = TRUE;
}

$rss_truncate_items = 1000;
if(!empty($CONFIG['rss_truncate_items']) && is_numeric($CONFIG['rss_truncate_items']))
  $rss_truncate_items = abs($CONFIG['rss_truncate_items']);

$rss_truncate_body = 50;
if(!empty($CONFIG['rss_truncate_body']) && is_numeric($CONFIG['rss_truncate_body']))
  $rss_truncate_body = abs($CONFIG['rss_truncate_body']);
  
$rss_truncate_body_parsing = 10;
if(!empty($CONFIG['rss_truncate_body_parsing']) && is_numeric($CONFIG['rss_truncate_body_parsing']))
  $rss_truncate_body_parsing = abs($CONFIG['rss_truncate_body_parsing']);  

$IMAP->set_caching(false);
$messagecount_unread  = $IMAP->count($mbox, 'UNSEEN', TRUE);
$messagecount         = $IMAP->count($mbox, 'ALL', TRUE);

if($flag == "unseen" && $messagecount_unread == 0)
  $rss_truncate_items = 0;

$sort_col = 'date';
$sort_order = 'DESC';

// Send global XML output
header('Content-type: text/xml');
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");                          // HTTP/1.0

echo '<?xml version="1.0" encoding="UTF-8"?>
	<rss version="2.0"
	 xmlns:dc="http://purl.org/dc/elements/1.1/"
	 xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
	 xmlns:admin="http://webns.net/mvcb/"
	 xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	 xmlns:content="http://purl.org/rss/1.0/modules/content/">';
	 
// Send channel-specific output
echo '
	<channel>
		<pubDate>'.date('r').'</pubDate>
		<lastBuildDate>'.date('r').'</lastBuildDate>
		<link>'.api_rss_encode($webmail_url) .'</link>
		<title>' . api_rss_encode($rcmail->config->get('product_name') . ' ::: ' . $_SESSION['username'] . " ::: " . ucwords($disp_mbox) . " (" . rcube_label('rss_feeds.rss_' . $flag) . ")") . '</title>
		<description>' . api_rss_encode(ucwords($disp_mbox)) . '</description>
		<generator>'.api_rss_encode($rcmail->config->get('useragent')).'</generator>
		<image>
			<link>' . api_rss_encode($webmail_url) . '</link>
			<title>'.api_rss_encode($rcmail->config->get('product_name')).'</title>
			<url>'.api_rss_encode($root_url . $rcmail->config->get('skin_path') .'/images/roundcube_logo.png').'</url>
		</image>';

// Check if the user wants to override the default sortingmethode
if (isset($_GET['_sort']))
  list($sort_col, $sort_order) = explode('_', get_input_value('_sort', RCUBE_INPUT_GET));

// Add message to output
if ($messagecount > 0){
  $IMAP->set_page_size = min($messagecount,$rss_truncate_items);
  $items = $IMAP->list_headers($mbox, null, $sort_col, $sort_order);
 
  $i = -1;
  foreach ($items as $item){
    if($item->$iflag == $cflag){
      $i++;

      $IMAP->set_charset($item->charset ? $item->charset : $rcmail->config->get('default_charset', 'UTF-8'));

      // Convert '"name" <email>' to 'email (name)'
      $item->from = $IMAP->decode_header($item->from, true);
      if (strstr($item->from, '<')){
        $item->from = preg_replace('~"?([^"]*)"? <([^>]*)>~', '\2 (\1)', $item->from);
      }

      $item->link = $webmail_url.'&_action=show&_uid='.$item->uid.'&_mbox=' . urlencode($mbox);
      
      if($i < $rss_truncate_body_parsing){

        $item->body = $IMAP->get_body($item->uid);
         
        $MESSAGE = new rcube_message($item->uid);

        $item->body = $MESSAGE->first_text_part();
            
        if(strlen($item->body) > $rss_truncate_body){
          $trailing = " ... [" . rcube_label('rss_feeds.truncated') . "]";
        }
        else{
          $trailing = "";
        }
        
        $description = '<description><![CDATA['."\n".nl2br(api_rss_encode(substr($item->body,0,$rss_truncate_body) . $trailing))."\n".']]></description>' . "\n";
      }
      else{
        $description = "";
      }
      
      $item->subject = $IMAP->decode_header($item->subject);

      if($subject == ""){
        $subject = rcube_label("nosubject");
      }

      $mz = "";
      $browser = new rcube_browser();
      if($browser->mz)
        $mz = " | " . $item->from;

      // Print the actual messages
      echo '
			<item>
				<title>'.api_rss_encode($item->subject . $mz).'</title>
				' . $description . '
				<link>'.api_rss_encode($item->link).'</link>
				<author>'.api_rss_encode($item->from).'</author>
				<guid>'.api_rss_encode($item->link).'</guid>
				<pubDate>'.date('r', $item->timestamp).'</pubDate>
			</item>';
    }
  }
}
else{
      echo '
			<item>
				<title>'.api_rss_encode($mbox . ': ' . rcube_label('rss_feeds.mboxempty')).'</title>
				<description></description>
				<link></link>
				<author></author>
				<guid></guid>
				<pubDate></pubDate>
			</item>';
}

echo '</channel>
</rss>';

exit;
?>
