<?php

/**
 * sticky_notes
 *
 * @version 4.7.2 - 20.10.2012
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 *
 **/
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 * Requirements: jqueryui plugin (do not register, plugin is loaded automatically)
 *
 * Notice: If you don't use plugin_manager, calendar plugin has to be registered before sticky_notes !!!
 *
 **/ 
 
/**
 *
 * Credits: http://demo.tutorialzine.com/2010/01/sticky-notes-ajax-php-jquery/demo.php
 *
 **/

/**
 *
 *  ToDo: Switch button if $count > 0 (need notes button merged with a red exclamation mark)
 *
 **/

class sticky_notes extends rcube_plugin
{
  public $task = '?(?!login|logout).*';

  private $sticky_notes = array();
  private $skin;
  private $calendar = false;
  private $notes = false;
  private $calendar_compat = '5.8';
  private $rcmail;
  
  /* unified plugin properties */
  static private $plugin = 'sticky_notes';
  static private $author = 'myroundcube@mail4us.net';
  static private $authors_comments = null;
  static private $download = 'http://myroundcube.googlecode.com';
  static private $version = '4.7.2';
  static private $date = '20-10-2012';
  static private $licence = 'GPL';
  static private $requirements = array(
    'Roundcube' => '0.8.1',
    'PHP' => '5.2.1',
    'required_plugins' => array(
      'jqueryui' => 'require_plugin',
    ),
    'recommended_plugins' => array(
      'global_config' => 'config',
    ),
  );
  static private $prefs = null;
  static private $config_dist = 'config.inc.php.dist';
  
  function init()
  {
    $rcmail = rcmail::get_instance();
    $this->rcmail = $rcmail;
    
    if(!in_array('global_config', $this->rcmail->config->get('plugins', array()))){
      $this->require_plugin('jqueryui');
      $this->load_config();
    }
    $pactive = $rcmail->config->get('plugin_manager_active', array());
    if($pactive['calendar'])
      $this->calendar = true;
    if(class_exists('calendar'))
      $this->calendar = true;
    $this->add_texts('localization/', true);
 
    $this->register_action('plugin.sticky_notes', array($this, 'startup'));
    $this->register_action('plugin.sticky_notes_return_sticky_notes', array($this, 'return_sticky_notes'));
    $this->register_action('plugin.sticky_notes_new_sticky_note', array($this, 'new_sticky_note'));
    $this->register_action('plugin.sticky_notes_edit_sticky_note', array($this, 'edit_sticky_note'));
    $this->register_action('plugin.sticky_notes_remove_sticky_note', array($this, 'remove_sticky_note'));
    $this->register_action('plugin.sticky_notes_unregister', array($this, 'unregister'));
    $this->register_action('plugin.sticky_notes_drag_sticky_note', array($this, 'drag_sticky_note'));
    $this->add_hook('template_object_sticky_notes_categories', array($this, 'generate_categories'));
    $this->add_hook('render_page', array($this, 'notes_count'));
       
    $skin = $rcmail->config->get('skin','classic');
    if(is_dir(INSTALL_PATH . 'plugins/sticky_notes/skins/' . $skin)){
      $this->skin = $skin;
    }
    else{
      $this->skin = 'classic';
    }
    $this->include_stylesheet('skins/' . $this->skin . '/sticky_notes.css');
    if($skin == 'larry')
      $this->include_stylesheet('skins/' . $this->skin . '/jquery.timepicker.css');
    $disp = 'inline';
    if($skin != 'groupvice4'){
      $this->include_script('move_button.js');
      $disp = 'none';
    }
    
    // add taskbar button
    $token = '';
    if(in_array('compressor', $rcmail->config->get('plugins', array()))){
      $token = '&_s=' . md5($_SESSION['language'] . 
          session_id() .
          $rcmail->config->get('skin', 'classic') . 
          self::$version . 
          self::$date . 
          serialize($rcmail->config->get('plugins', array())) .
          serialize($rcmail->config->get('plugin_manager_active', array()))
         );
    }
    $this->add_button(array(
      'name'    => 'sticky_notes',
      'class'   => 'button-sticky_notes',
      'content' => html::tag('span', array('class' => 'button-inner'), $this->gettext('sticky_notes.sticky_notes')),
      'href'    => './?_task=dummy&_action=plugin.sticky_notes' . $token,
      'id'      => 'sticky_notes_button',
      'style'   => 'display: ' . $disp . ';'
    ), 'taskbar');
  }
  
  static public function about($keys = false)
  {
    $requirements = self::$requirements;
    foreach(array('required_', 'recommended_') as $prefix){
      if(is_array($requirements[$prefix.'plugins'])){
        foreach($requirements[$prefix.'plugins'] as $plugin => $method){
          if(class_exists($plugin) && method_exists($plugin, 'about')){
            /* PHP 5.2.x workaround for $plugin::about() */
            $class = new $plugin(false);
            $requirements[$prefix.'plugins'][$plugin] = array(
              'method' => $method,
              'plugin' => $class->about($keys),
            );
          }
          else{
             $requirements[$prefix.'plugins'][$plugin] = array(
               'method' => $method,
               'plugin' => $plugin,
             );
          }
        }
      }
    }
    $rcmail_config = array();
    if(is_string(self::$config_dist)){
      if(is_file($file = INSTALL_PATH . 'plugins/' . self::$plugin . '/' . self::$config_dist))
        include $file;
      else
        write_log('errors', self::$plugin . ': ' . self::$config_dist . ' is missing!');
    }
    $ret = array(
      'plugin' => self::$plugin,
      'version' => self::$version,
      'date' => self::$date,
      'author' => self::$author,
      'comments' => self::$authors_comments,
      'licence' => self::$licence,
      'download' => self::$download,
      'requirements' => $requirements,
    );
    if(is_array(self::$prefs))
      $ret['config'] = array_merge($rcmail_config, array_flip(self::$prefs));
    else
      $ret['config'] = $rcmail_config;
    if(is_array($keys)){
      $return = array('plugin' => self::$plugin);
      foreach($keys as $key){
        $return[$key] = $ret[$key];
      }
      return $return;
    }
    else{
      return $ret;
    }
  }
  
  private function q($str)
  {
    return $this->rcmail->db->quoteIdentifier($str);
  }
  
  private function table($str)
  {
    return $this->rcmail->db->quoteIdentifier(get_table_name($str));
  }
  
  function notes_count($p){
    if($p['template'] == 'planner.planner'){
      $this->include_script("planner_drag_notes.js");
    }
    // add styles
    $this->rcmail->output->set_env('sticky_skin',$this->skin);
    if($p['template'] != 'sticky_notes.sticky_notes' && !get_input_value('_framed', RCUBE_INPUT_GPC)){
      if(!is_array($this->notes))
        $this->notes = $this->get_sticky_notes();
      if(count($this->notes) > 0){
        if($this->rcmail->config->get('sticky_notes_count_img', false) && $this->skin != 'larry'){
          $this->rcmail->output->add_script('$("#taskbar a.button-sticky_notes").css("background-image","url(\'plugins/sticky_notes/skins/' . $this->skin . '/images/sticky_notes.php?_count=' . count($this->notes) . '\')")', 'docready');
        }
        else{
          $this->rcmail->output->add_script('$("#sticky_notes_button").html($("#sticky_notes_button").html() + "&nbsp;(<span id=\"sticky_notes_count\">' . count($this->notes) . '</span>)");', 'docready');
        }
      }
    }
  }
  
  function generate_categories($p){
    $rcmail = rcmail::get_instance();
    $p['content'] = '';
    if($this->calendar && method_exists('calendar', 'version') && calendar::version() > $this->calendar_compat && $rcmail->config->get('categories')){
      $categories = array_merge((array)$rcmail->config->get('public_categories',array()),(array)$rcmail->config->get('categories',array()));
      if(!empty($categories)){
        $p['content'] .= '<div class="color yellow" title="' . $this->gettext('sticky_notes.default') . '"></div>' . "\n";
        foreach ($categories as $class => $color) {
          $classascii = asciiwords($class,true,'');
          $p['content'] .= '<div class="color ' . $classascii . '" title="' . $class . '"></div>' . "\n";
        }
      }
    }
    else{
      $p['content']  = '<div class="color yellow"></div>' . "\n";
      $p['content'] .= '<div class="color blue"></div>' . "\n";
      $p['content'] .= '<div class="color green"></div>' . "\n";
    }
    return $p;
  }
     
  function startup()
  {
    $rcmail = $this->rcmail;
    if($this->calendar && method_exists('calendar', 'version') && calendar::version() > $this->calendar_compat && $rcmail->config->get('categories')){
      require_once('./plugins/calendar/program/utils.php');
      $this->utils = new Utils($rcmail, null);
      $rcmail->output->add_header('<link rel="stylesheet" type="text/css" href="plugins/calendar/skins/' . $this->skin . '/jquery.timepicker.css" />');
      $rcmail->output->add_header('<script type="text/javascript" src="plugins/calendar/program/js/jquery.timepicker.js"></script>');
      $rcmail->output->add_header(calendar::generateCSS(false,false));
    }
    else{
      $css = '
<style type="text/css">
.yellow{
	background-color:#FDFB8C;
	border:1px solid #DEDC65;	
}

.blue{
	background-color:#A6E3FC;
	border:1px solid #75C5E7;	
}

.green{
	background-color:#A5F88B;
	border:1px solid #98E775;	
}
</style>
';
      $rcmail->output->add_header($css);
    }
    $this->include_stylesheet('skins/' . $this->skin . '/styles.css');
    $this->include_stylesheet('fancybox/jquery.fancybox-1.2.6.css');
    $this->include_script("sticky_notes.js");
    $this->include_script("fancybox/jquery.fancybox-1.2.6.pack.js");
    if($this->rcmail->config->get('sticky_notes_count_img', false) && $this->rcmail->config->get('skin') != 'larry'){
      $this->rcmail->output->set_env('sticky_gd',true);
    }
    $rcmail->output->send('sticky_notes.sticky_notes');
  }
  
  function return_sticky_notes(){
    $reorder = get_input_value('_reorder', RCUBE_INPUT_POST);
    $maxheight = get_input_value('_maxheight', RCUBE_INPUT_POST);
    $maxwidth = get_input_value('_maxwidth', RCUBE_INPUT_POST);
    $notes = $this->get_sticky_notes();
    $occupied = array();
    $lastzindex = 0;
    $lasttop = -20;
    $lastleft = -28;
    $html = '';
    foreach($notes as $key =>$note){
      $left = $note['pos_y'];
      $top = $note['pos_x'];
      $id = $note['id'];
      if($reorder){
        $zindex ++;
        $occupied[$left.$top] = 0;
      }
      else{
        $zindex = $note['nid'];
        $lastzindex = max($zindex,$lastzindex);
      }
      $arrtext = unserialize($note['text']);
      if(is_array($arrtext)){
        $summary = htmlspecialchars($arrtext[0]);
        $text = htmlspecialchars($arrtext[1]);
        $color = $arrtext[2];
      }
      else{
        $text = htmlspecialchars($note['text']);
        $summary = '';
        $color = 'yellow';
      }
      if(isset($occupied[$left.$top])){
        $left = $lastleft + 28;
        $top = $lasttop + 20;
        $lastleft = $left;
        $lasttop = $top;
        if(!$reorder)
          $zindex = max($zindex,$lastzindex+1);
      }
      else{
        $occupied[$left.$top] = 0;
      }
      if($maxheight && $maxwidth){
        $top = min($maxheight - 175, $top);
        $left = min($maxwidth - 175, $left);
        if($occupied[$left.$top] >= 1){
          $lasttop = 0;
          $lastleft = 230;
          $top = min($maxheight - 175, $lasttop);
          $left = min($maxwidth - 175, $lastleft);
          while($occupied[$left.$top]){
            $lastleft = $lastleft + 230;
            $lasttop = $lasttop + 20;
            $top = min($maxheight - 175, $lasttop);
            $left = min($maxwidth - 175, $lastleft);
            if($top != $lasttop && $left != $lastleft)
              break;
          }
          $top = min($maxheight - 175, $lasttop);
          $left = min($maxwidth - 175, $lastleft);
          if($occupied[$left.$top] >= 1){
            $lasttop = 230;
            $lastleft = 0;
            $top = min($maxheight - 175, $lasttop);
            $left = min($maxwidth - 175, $lastleft);
            while($occupied[$left.$top]){
              $lasttop = $lasttop + 230;
              $lastleft = $lastleft + 28;
              $top = min($maxheight - 175, $lasttop);
              $left = min($maxwidth - 175, $lastleft);
              if($top != $lasttop && $left != $lastleft)
                break;
            }
          }
        }
      }
      $occupied[$left.$top] = $occupied[$left.$top] + 1;
      $html.= '
  <div id="' . $id . '" class="note default '.$color.'" style="left:'.$left.'px;top:'.$top.'px;z-index:'.$zindex.'">
    <div id="t' . $id . '" title="' . $text . '"><p class="body">'.nl2br($text).'</p></div>
    <div id="a' . $id . '" class="summary ' . $color . '" style="border:0px;text-align:right;width:110px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;-o-text-overflow:ellipsis;" title="' . $summary . '">'.$summary.'</div>
    <div id="_' . $id . '" class="delete" title="' . $summary . '"><a href="#">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</a></div>
    <div class="edit"><a class="edit-f" id="edit' . $id . '" href="./?_task=dummy&_action=plugin.sticky_notes_edit_sticky_note&_form=1&_id=' . $id . '&_' . time() . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</a></div>
    <span class="data">'.$id.'</span>
  </div>';
      if($reorder){
        $_POST['_zindex'] = $zindex;
        $_POST['_pos_y'] = $top;
        $_POST['_pos_x'] = $left;
        $_POST['_id'] = $id;
        $this->drag_sticky_note(false);
      }
    }
    $this->rcmail->output->set_pagetitle($this->gettext('sticky_notes'));
    $this->rcmail->output->command('plugin.sticky_notes_return_sticky_notes', array(0 => count($notes), 1 => $html));
  }
  
  function GMT_time($t)
  {
    return date('Y-m-d H:i:s',$t - date('Z'));
  }
  
  function new_sticky_note()
  {
    $rcmail = $this->rcmail;
    if($_GET['_form']){
      if($include = @file_get_contents('./plugins/sticky_notes/skins/includes/add_note.html')){
        echo rcmail::get_instance()->output->just_parse($include);
      }
      exit;
    }
    if (!empty($rcmail->user->ID)) {
      $props = array();
      $props[] = get_input_value('_summary', RCUBE_INPUT_POST);
      $props[] = get_input_value('_text', RCUBE_INPUT_POST);
      $props[] = get_input_value('_color', RCUBE_INPUT_POST);
      $text = serialize($props);
      $pos_x = 0;
      $pos_y = 0;
      $width = 0;
      $height = 0;
      $nid = get_input_value('_zindex', RCUBE_INPUT_POST);
      if(!$nid){
        $result = $rcmail->db->query(
          "SELECT MAX(" . $this->q('nid') . ") as " . $this->q('nid') . " FROM " . $this->table('notes') . " WHERE " . $this->q('user_id') . "=?",
          $rcmail->user->ID
        );
        while ($result && ($note = $rcmail->db->fetch_assoc($result))) {
          $nid = ((int) $note['nid']) + 1;
        }
      }

      $query = $rcmail->db->query(
        "INSERT INTO " . $this->table('notes') . "
         (".$this->q('user_id').", ".$this->q('nid').", ".$this->q('pos_x').", ".$this->q('pos_y').", ".$this->q('width').", ".$this->q('height').", ".$this->q('text').", ".$this->q('timestamp').")
         VALUES (?, ?, ?, ?, ?, ?, ?, ?)",
         $rcmail->user->ID,
         $nid,
         $pos_x,
         $pos_y,
         $width,
         $height,
         $text,
         $this->GMT_time(time())
      );
    }
    $id = get_input_value('_id', RCUBE_INPUT_POST);
    if(!$id){
      $this->return_sticky_notes();
    }
    else{
      $this->rcmail->output->command('plugin.planner_drop_success', $id);
    }
  }

  function edit_sticky_note($ajax=false)
  {
    $rcmail = $this->rcmail;
    if($_GET['_form'] && $_GET['_id']){
      if($include = @file_get_contents('./plugins/sticky_notes/skins/includes/edit_note.html')){
        if($this->calendar && method_exists('calendar', 'version') && calendar::version() > $this->calendar_compat){
          $include .= '<!-- Move Note to calendar: -->' . "\n";
          $include .= '<div id="calicon" title="' . $this->gettext('sticky_notes.move_to_calendar') . '"></div><div id="date"><input type="text" id="date-f" readonly="readonly" /></div>' . "\n";
          $include .= '<script type="text/javascript" src="plugins/sticky_notes/calendar.js"></script>' . "\n";
        }
        $notes = $this->get_sticky_notes(get_input_value('_id', RCUBE_INPUT_GPC));
        $note = $notes[0];
        $id = $note['id'];
        $arrtext = unserialize($note['text']);
        if(is_array($arrtext)){
          $summary = htmlspecialchars($arrtext[0]);
          $text = htmlspecialchars($arrtext[1]);
          $color = $arrtext[2];
        }
        else{
          $text = htmlspecialchars($note['text']);
          $summary = '';
          $color = 'yellow';
        }
        $include = str_replace('$id$', $id, $include);
        $include = str_replace('$color$', $color, $include);
        $include = str_replace('$summary$', $summary, $include);
        $include = str_replace('$textbody$', nl2br($text), $include);
        $include = str_replace('$text$', $text, $include);
        echo rcmail::get_instance()->output->just_parse($include);
      }
      exit;
    }
    if (!empty($rcmail->user->ID)) {
      $props = array();
      $props[] = get_input_value('_summary', RCUBE_INPUT_POST);
      $props[] = get_input_value('_text', RCUBE_INPUT_POST);
      if(!$color = get_input_value('_color', RCUBE_INPUT_POST)){
        $color = 'yellow';
      }
      $props[] = $color;
      $text = serialize($props);

      $id = get_input_value('_id', RCUBE_INPUT_POST);

      $query = $rcmail->db->query(
        "UPDATE " . $this->table('notes') . " 
         SET ".$this->q('text')."=?, ".$this->q('timestamp')."=?
         WHERE ".$this->q('id')."=?
         AND ".$this->q('user_id')."=?",
         $text,
         $this->GMT_time(time()),
         $id,
         $rcmail->user->ID
      );
    }
    if($ajax)
      $this->return_sticky_notes();
  }
  
  function remove_sticky_note($ajax=false)
  {
    $rcmail = $this->rcmail;
    
    if (!empty($rcmail->user->ID)) {
      $id = get_input_value('_id', RCUBE_INPUT_POST);
      $query = $rcmail->db->query(
      "DELETE FROM " . $this->table('notes') . "
       WHERE ".$this->q('id')."=?
       AND ".$this->q('user_id')."=?",
       $id,
       $rcmail->user->ID
      );
    }
    if($ajax)
      $this->return_sticky_notes();
  }
  
  function unregister()
  {
    $rcmail = $this->rcmail;
    
    if (!empty($rcmail->user->ID)) {
      $id = get_input_value('_id', RCUBE_INPUT_POST);
      $query = $rcmail->db->query(
      "DELETE FROM " . $this->table('notes') . "
       WHERE ".$this->q('user_id')."=?",
       $rcmail->user->ID
      );
    }
    
    $rcmail->output->command('plugin.plugin_manager_success', '');
  }
  
  function drag_sticky_note($ajax=false)
  {
    $rcmail = $this->rcmail;
    
    if (!empty($rcmail->user->ID)) {
      $id = get_input_value('_id', RCUBE_INPUT_POST);
      $zindex = get_input_value('_zindex', RCUBE_INPUT_POST);
      $pos_y = get_input_value('_pos_x', RCUBE_INPUT_POST);
      $pos_x = get_input_value('_pos_y', RCUBE_INPUT_POST);
      $query = $rcmail->db->query(
        "UPDATE " . $this->table('notes') . " 
         SET ".$this->q('pos_x')."=?, ".$this->q('pos_y')."=?, ".$this->q('nid')."=?, ".$this->q('timestamp')."=?
         WHERE ".$this->q('id')."=?
         AND ".$this->q('user_id')."=?",
         $pos_x,
         $pos_y,
         $zindex,
         $this->GMT_time(time()),
         $id,
         $rcmail->user->ID
      );
    }
    if($ajax)
      $this->return_sticky_notes();
  }

  public function get_sticky_notes($id=false)
  {
    if(is_array($this->notes))
      return $this->notes;
    $rcmail = rcmail::get_instance();
    if($rcmail->user->ID != $_SESSION['user_id'])
      $rcmail->user->ID = $_SESSION['user_id'];
      
    if (!empty($rcmail->user->ID)) {
      if($id){
        $append = ' AND '.$this->q('id').'=?';
      }
      else{
        $append = ' AND '.$this->q('id').'<>?';
        $id = -1;
      }
      $result = $rcmail->db->query(
        "SELECT * FROM " . $this->table('notes') . " 
         WHERE ".$this->q('user_id')."=?".$append,
         $rcmail->user->ID,
         $id
       );
      $notes = array(); 
      while ($result && ($note = $rcmail->db->fetch_assoc($result))) {
        $notes[]=array( 
          'id'     => (int) $note['id'],
          'nid'    => (int) $note['nid'],
          'text'   => (string) $note['text'],
          'pos_x'  => (int) $note['pos_x'],
          'pos_y'  => (int) $note['pos_y'],
          'width'  => max(100,(int)$note['width']),
          'height' => max(70,(int)$note['height'])
        );
      }
      return $notes;
    }
  }
}  
?>